unit TestThread.Trim.Helper.Partition;
{

  Delphi DUnit Test Case
  ----------------------
  This unit contains a skeleton test case class generated by the Test Case Wizard.
  Modify the generated code to correctly setup and call the methods from the unit 
  being tested.

}

interface

uses
  TestFramework, OS.ProcessOpener, Thread.Trim.Helper.Partition.OS, SysUtils;

type
  // Test methods for class TOSPartitionTrimmer

  TestTOSPartitionTrimmer = class(TTestCase)
  strict private
    FOSPartitionTrimmer: TOSPartitionTrimmer;
  public
    procedure SetUp; override;
    procedure TearDown; override;
  published
    procedure TestParseProgress;
  end;

implementation

const
  DriveOptimizerString83: String =
    'Microsoft Drive Optimizer'#$D#$A +
    'Copyright (c) 2013 Microsoft Corp.'#$D#$A#$D#$A +
    'ٽ ߶󳻱(Windows (C:)) ȣ ...'#$D#$D#$A#$D#$A#$D#$A +
    '1 ܰ踦 ϴ '#$D#$A#$D#9 +
    'ٽ ߶󳻱:  0% Ϸ...'#$D#9 +
    'ٽ ߶󳻱:  57% Ϸ...'#$D#9 +
    'ٽ ߶󳻱:  58% Ϸ...'#$D#9 +
    'ٽ ߶󳻱:  69% Ϸ...'#$D#9 +
    'ٽ ߶󳻱:  71% Ϸ...'#$D#9 +
    'ٽ ߶󳻱:  72% Ϸ...'#$D#9 +
    'ٽ ߶󳻱:  83% Ϸ...'#$D#9;

  DriveOptimizerString100: String =
    'Microsoft Drive Optimizer'#$D#$A +
    'Copyright (c) 2013 Microsoft Corp.'#$D#$A#$D#$A +
    'ٽ ߶󳻱(Windows (C:)) ȣ ...'#$D#$D#$A#$D#$A#$D#$A +
    '1 ܰ踦 ϴ '#$D#$A#$D#9 +
    'ٽ ߶󳻱:  0% Ϸ...'#$D#9 +
    'ٽ ߶󳻱:  57% Ϸ...'#$D#9 +
    'ٽ ߶󳻱:  58% Ϸ...'#$D#9 +
    'ٽ ߶󳻱:  69% Ϸ...'#$D#9 +
    'ٽ ߶󳻱:  71% Ϸ...'#$D#9 +
    'ٽ ߶󳻱:  72% Ϸ...'#$D#9 +
    'ٽ ߶󳻱:  83% Ϸ...'#$D#9 +
    'ٽ ߶󳻱:  93% Ϸ...'#$D#9 +
    'ٽ ߶󳻱:  100% Ϸ.  '#$D#$A#$D#$A +
    '۾ Ϸ߽ϴ.'#$D#$A#$D#$A +
    'Post Defragmentation Report:'#$D#$A#$D#$D#$A#9 +
    ' :'#$D#$A#9#9 +
    ' ũ                 = 111.34 GB'#$D#$A#9#9 +
    '';

procedure TestTOSPartitionTrimmer.SetUp;
begin
  FOSPartitionTrimmer := TOSPartitionTrimmer.Create('');
end;

procedure TestTOSPartitionTrimmer.TearDown;
begin
  FOSPartitionTrimmer.Free;
  FOSPartitionTrimmer := nil;
end;

procedure TestTOSPartitionTrimmer.TestParseProgress;
begin
  FOSPartitionTrimmer.ParseProgress(DriveOptimizerString83);
  CheckEquals(83, FOSPartitionTrimmer.Progress);
  FOSPartitionTrimmer.ParseProgress(DriveOptimizerString100);
  CheckEquals(100, FOSPartitionTrimmer.Progress);
end;

initialization
  // Register any test cases with the test runner
  RegisterTest(TestTOSPartitionTrimmer.Suite);
end.

